
//**********************************************************
//**                      Bug Wars                        **
//**                         by                           **
//**                  Jose Manuel Habas                   **
//**                                                      **
//**                           Amaka Soft 2000 - 2002/04  **
//**********************************************************

program bugwars;
  global
    ux;uy;

    puntos;
    life;
    energia;

    hi_score=12500;

    bloquea_prota; destapado;

    fichero0;fichero1;fichero2;
    fuente;

    musica;
    sonido0; sonido1;
    
    enemigos;
    
  begin
    fichero0=load_fpg("graficos/titulo.fpg");
    load_pal("graficos/titulo.fpg");
    
    //set_icon(fichero0,4);
    //set_title("-= Bug Wars Special Edition =-");
    
    //full_screen=0;
    graph_mode=mode_16bits;
    set_mode(m320x240);
    define_region(1,0,20,320,200);

    fuente=load_fnt("fuentes/bugwars.fnt");

    sonido0=load_wav("music_sound/escupe.wav");
    sonido1=load_wav("music_sound/muerte.wav");

    amakasoft();
end


process amakasoft();
  private;
    anima=0;
    vel=0;
    tiempo=0;

  begin
    fade_off();
    let_me_alone();
    
    load_pal("graficos/bugs.fpg");

    write(fuente,160,90,4,"Bug Wars Special Edition");
    write(fuente,160,100,4,"es un producto de Amaka Soft.");
    write(fuente,160,110,4,"Creado por Jose Manuel Habas Millan");
    write(fuente,160,130,4,"www.amakasoft.net");
    fade_on();

    frame(12000);
    fade_off();

    delete_text(all_text);
    unload_fpg(fichero0);

    fichero0=load_png("graficos/amakasoft.png");
    fade_on();

    frame(500);
    graph=fichero0;
    x=160;
    y=120;
    region=1;

  loop
    tiempo=tiempo+1; if (tiempo>160) inicio();end

  frame;
  end
end


process inicio();
  begin
    fade_off();
    let_me_alone();
    unload_map(0,fichero0);

    stop_song();
    unload_song(musica);

    musica=load_song("music_sound/stories.mod");
    play_song(musica,-1);

    fichero0=load_fpg("graficos/titulo.fpg");
    fichero1=load_fpg("graficos/bugs.fpg");
    fichero2=load_fpg("graficos/escenario.fpg");
    load_pal("graficos/titulo.fpg");
    fade_on();
    
    puntos=0;
    life=3;
    energia=26;
    load("record.sav",hi_score);

    foto(5,160,120,100,30,0,fichero0);

  loop
    if (key(_enter)) juego();break;end
    if (key(_space)) exit("Amaka Soft 2000 - 2002",0);end

  frame;
  end
end


process foto(graph,x,y,size,z,flags,file);
  begin
    region=1;
  
  loop
  frame;
  end
end


process juego();
  begin
    pantalla_tapada(4,fichero0,1000,0);

    signal(type foto,s_kill);

  frame(5000);
    escenario();
end


process escenario();
  begin
    let_me_alone();
    load_pal("graficos/bugs.fpg");

    stop_song();
    unload_song(musica);
    
    musica=load_song("music_sound/miracles.mod");
    play_song(musica,-1);

    text_z=-5;
    bloquea_prota=1;
    destapado=1;
    
    titulo_escenario();
    pantalla_tapada(18,fichero1,11000,1);    //12600

    foto(34,50,31,100,-5,0,fichero1);
    foto(35,50,31,100,0,4,fichero1);
    foto(35,50,31,100,0,4,fichero1);

    energy();
    foto(44,155,31,100,0,4,fichero1);
    foto(44,155,31,100,0,4,fichero1);

    vidas(101,32,1);
    vidas(115,32,2);
    vidas(129,32,3);

    prota(-40,140,1);
    fondo();

    write_int(1,50,30,4,offset puntos);
    write_int(1,160,210,4,offset hi_score);

    decorado(3,160,130,100,60,4,-160,476);
    decorado(3,480,130,100,60,4,-160,476);

    decorado(2,320,140,100,50,6,-640,632);
    decorado(2,960,140,100,50,6,-640,634);

  frame(10000);
    //decorado(1,640,180,200,10,10,-640,1910);
    //decorado(1,1920,180,200,10,10,-640,1910);
    
    //decorado(6,5000,90,80,80,3,-1000,5000);

    bloquea_prota=0;

  frame(5000);
    destapado=0;
    
    batallon(1);
end


process batallon(tipo);
  private;
    id_texto;
  
  begin
    frame(6000);
    
    if (tipo==1)
      enemigos=12;
      id_texto=foto(9,160,110,100,-10,0,fichero2);

      frame(4000);
      signal(id_texto,s_kill);
      
      enemigo01(220,80);
      enemigo01(220,140);
      enemigo01(260,50);
      enemigo01(260,80);
      enemigo01(260,110);
      enemigo01(260,140);
      enemigo01(260,170);
      enemigo01(300,50);
      enemigo01(300,80);
      enemigo01(300,110);
      enemigo01(300,140);
      enemigo01(300,170);
    end

    if (tipo==2)
      enemigos=12;
      id_texto=foto(10,160,110,100,-10,0,fichero2);

      foto(17,188,31,100,-10,0,fichero1);

      frame(4000);
      signal(id_texto,s_kill);

      enemigo01(220,90);
      enemigo01(220,120);
      enemigo01(260,60);
      enemigo01(260,90);
      enemigo01(260,120);
      enemigo01(260,150);
      enemigo01(300,30);
      enemigo01(300,60);
      enemigo01(300,90);
      enemigo01(300,120);
      enemigo01(300,150);
      enemigo01(300,180);
    end

    if (tipo==3)
      enemigos=20;
      id_texto=foto(11,160,110,100,-10,0,fichero2);
      
      foto(17,200,31,100,-10,0,fichero1);
      
      frame(4000);
      signal(id_texto,s_kill);

      enemigo01(180,60);
      enemigo01(180,90);
      enemigo01(180,120);
      enemigo01(180,150);
      enemigo01(220,60);
      enemigo01(220,90);
      enemigo01(220,120);
      enemigo01(220,150);
      enemigo01(260,30);
      enemigo01(260,60);
      enemigo01(260,90);
      enemigo01(260,120);
      enemigo01(260,150);
      enemigo01(260,180);
      enemigo01(300,30);
      enemigo01(300,60);
      enemigo01(300,90);
      enemigo01(300,120);
      enemigo01(300,150);
      enemigo01(300,180);
    end

    if (tipo==4)
      enemigos=11;
      id_texto=foto(12,160,110,100,-10,0,fichero2);

      foto(17,212,31,100,-10,0,fichero1);

      frame(4000);
      signal(id_texto,s_kill);
      
      enemigo02(220-5,50-5);
      enemigo01(220,110);
      enemigo02(220-5,170-5);
      enemigo01(260,80);
      enemigo01(260,110);
      enemigo01(260,140);
      enemigo01(300,50);
      enemigo02(300-5,80-5);
      enemigo02(300-5,110-5);
      enemigo02(300-5,140-5);
      enemigo01(300,170);
    end

    if (tipo==5)
      enemigos=9;
      id_texto=foto(13,160,110,100,-10,0,fichero2);

      foto(17,224,31,100,-10,0,fichero1);

      frame(4000);
      signal(id_texto,s_kill);
      
      enemigo02(220-5,110-5);
      enemigo01(260,80);
      enemigo01(260,110);
      enemigo01(260,140);
      enemigo02(300-5,50-5);
      enemigo02(300-5,80-5);
      enemigo02(300-5,110-5);
      enemigo02(300-5,140-5);
      enemigo02(300-5,170-5);
    end

    if (tipo==6)
      enemigos=10;
      id_texto=foto(14,160,110,100,-10,0,fichero2);

      foto(17,236,31,100,-10,0,fichero1);

      frame(4000);
      signal(id_texto,s_kill);

      enemigo01(220,50);
      enemigo01(220,170);
      enemigo01(260,50);
      enemigo02(260-5,110-5);
      enemigo01(260,170);
      enemigo01(300,50);
      enemigo02(300-5,80-5);
      enemigo02(300-5,110-5);
      enemigo02(300-5,140-5);
      enemigo01(300,170);
    end

    if (tipo==7)
      enemigos=12;
      id_texto=foto(15,160,110,100,-10,0,fichero2);

      foto(17,248,31,100,-10,0,fichero1);

      frame(4000);
      signal(id_texto,s_kill);

      enemigo02(180-5,90-5);
      enemigo02(180-5,120-5);
      enemigo02(220-5,30-5);
      enemigo02(220-5,60-5);
      enemigo02(220-5,150-5);
      enemigo02(220-5,180-5);
      enemigo02(260-5,30-5);
      enemigo02(260-5,60-5);
      enemigo02(260-5,150-5);
      enemigo02(260-5,180-5);
      enemigo02(300-5,90-5);
      enemigo02(300-5,120-5);
    end

    if (tipo==8)
      enemigos=12;
      id_texto=foto(16,160,110,100,-10,0,fichero2);

      foto(17,260,31,100,-10,0,fichero1);

      frame(4000);
      signal(id_texto,s_kill);

      enemigo01(220,30);
      enemigo01(220,60);
      enemigo01(220,90);
      enemigo01(220,120);
      enemigo01(220,150);
      enemigo01(220,180);
      enemigo02(260-5,60-5);
      enemigo02(260-5,90-5);
      enemigo02(260-5,120-5);
      enemigo02(260-5,150-5);
      enemigo03(300,90);
      enemigo03(300,120);
    end

    if (tipo==9)
      enemigos=15;
      id_texto=foto(17,160,110,100,-10,0,fichero2);

      foto(17,272,31,100,-10,0,fichero1);

      frame(4000);
      signal(id_texto,s_kill);

      enemigo01(220,50);
      enemigo02(220-5,80-5);
      enemigo03(220,110);
      enemigo01(220,140);
      enemigo01(220,170);
      enemigo02(260-5,50-5);
      enemigo03(260,80);
      enemigo02(260-5,110-5);
      enemigo03(260,140);
      enemigo02(260-5,170-5);
      enemigo03(300,50);
      enemigo01(300,80);
      enemigo01(300,110);
      enemigo02(300-5,140-5);
      enemigo03(300,170);
    end

    if (tipo==10)
      enemigos=16;
      id_texto=foto(18,160,110,100,-10,0,fichero2);

      foto(17,284,31,100,-10,0,fichero1);

      frame(4000);
      signal(id_texto,s_kill);

      enemigo03(180,50);
      enemigo03(180,170);
      enemigo03(220,50);
      enemigo01(220,80);
      enemigo01(220,140);
      enemigo03(220,170);
      enemigo03(260,50);
      enemigo01(260,80);
      enemigo02(260-5,110-5);
      enemigo01(260,140);
      enemigo03(260,170);
      enemigo03(300,50);
      enemigo01(300,80);
      enemigo02(300-5,110-5);
      enemigo01(300,140);
      enemigo03(300,170);
    end

    if (tipo==11)
      enemigos=12;
      id_texto=foto(19,160,110,100,-10,0,fichero2);

      foto(17,296,31,100,-10,0,fichero1);

      frame(4000);
      signal(id_texto,s_kill);
      
      enemigo03(180,90);
      enemigo03(180,120);
      enemigo03(220,30);
      enemigo03(220,60);
      enemigo03(220,150);
      enemigo03(220,180);
      enemigo03(260,90);
      enemigo03(260,120);
      enemigo03(300,30);
      enemigo03(300,60);
      enemigo03(300,150);
      enemigo03(300,180);
    end
    
    if (tipo==12)
      enemigos=24;
      id_texto=foto(20,160,110,100,-10,0,fichero2);

      foto(17,308,31,100,-10,0,fichero1);

      frame(4000);
      signal(id_texto,s_kill);

      enemigo02(180-5,30-5);
      enemigo01(180,60);
      enemigo03(180,90);
      enemigo03(180,120);
      enemigo01(180,150);
      enemigo02(180-5,180-5);
      enemigo03(220,30);
      enemigo03(220,60);
      enemigo03(220,90);
      enemigo03(220,120);
      enemigo03(220,150);
      enemigo03(220,180);
      enemigo02(260-5,30-5);
      enemigo02(260-5,60-5);
      enemigo02(260-5,90-5);
      enemigo02(260-5,120-5);
      enemigo02(260-5,150-5);
      enemigo02(260-5,180-5);
      enemigo01(300,30);
      enemigo01(300,60);
      enemigo01(300,90);
      enemigo01(300,120);
      enemigo01(300,150);
      enemigo01(300,180);
    end
    
  loop
    if (enemigos==0)
       tipo=tipo+1;
       if (tipo>12)
         frame(10000);
         bloquea_prota=2;
         frame(6000);
         final();
       else
         batallon(tipo);
         break;
       end
    end
    if (puntos>hi_score) hi_score=puntos;end
    
  frame;
  end
end


process pantalla_tapada(graph,file,tiempo_des,tipo_des);
  private;
    veces=0;
    sube=21;
    prd=0;
    grafic=100;

  begin
    y=20;
    region=1;

  loop
    if (prd==0)
      if (veces>1) sube=sube-1;veces=0;end
      if (sube<1) prd=1;end
    end

    if (prd==1)
      if (veces>1) sube=sube+1;veces=0;end
      if (sube>20) prd=0;end
    end
    
    veces=veces+1; 
    tapa_pantalla(graph,160,y,file,sube,tiempo_des,tipo_des,grafic);
    y=y+1; if (y>220) break;end
    grafic=grafic+1;
    
  frame(0);
  end
end


process tapa_pantalla(graph,x,y,file,veloc_x_tapa,t_d,tipo,grafic);
  private;
    turn_tapa=0;
  begin
    size=100;

    if (tipo==0) z=-50;graph=grafic;end
    if (tipo==1) z=-10;end
    region=1;

    frame(t_d);

  loop
    if (tipo==0)
      x=x+veloc_x_tapa;

      if (turn_tapa==0)
        veloc_x_tapa-=1;if (veloc_x_tapa<0) turn_tapa=1;end
      end

      if (turn_tapa==1)
        veloc_x_tapa+=1;if (veloc_x_tapa>21) turn_tapa=0;end
      end

      if (x>640) break;end
    end

    if (tipo==1)
      x=x-veloc_x_tapa;

      if (turn_tapa==0)
        veloc_x_tapa-=1;if (veloc_x_tapa<0) turn_tapa=1;end
      end

      if (turn_tapa==1)
        veloc_x_tapa+=1;if (veloc_x_tapa>21) turn_tapa=0;end
      end

      if (x<-320) break;end
    end

  frame;
  end
end


process prota(x,y,fuera_de_pantalla);
  private;
    ojos;
    anima=0;
    disparando=0;
    id_disparo;

  begin
    graph=1;
    size=100;
    z=20;
    file=fichero1;
    region=1;
    ux=x; uy=y;
    alas(x,y,size,15);

  loop
    if (fuera_de_pantalla==0)
      if (disparando==0)
        ojos=rand(0,100);if (ojos==0 or ojos==1) anima=3;end
      end

      anima=anima+1;

      if (bloquea_prota==0)
        if (key(_up) and y>40) y=y-4;end
        if (key(_down) and y<200) y=y+4;end
        if (key(_left) and x>20) x=x-4;end
        if (key(_right) and x<300) x=x+4;end
        if (disparando==0)
          if (key(_control) or key(_alt) or key(_x)) disparando=1;anima=14;end
        end
        if (key(_space))
          fade_off();
         
          stop_scroll(0);
          delete_text(all_text);
         
          amakasoft();
        end
      end
      if (bloquea_prota==2) x=x+6;end

      if (anima==1) graph=1;end
      if (anima==2) anima=0;end

      if (anima==3) graph=5;end
      if (anima==4) graph=6;end
      if (anima==5) graph=7;end
      if (anima==6) graph=8;end
      if (anima==7) graph=9;end
      if (anima==8) graph=8;end
      if (anima==9) graph=7;end
      if (anima==10) graph=6;end
      if (anima==11) graph=5;end
      if (anima==12) graph=1;end
      if (anima==13) anima=11;end

      if (anima==14) graph=2;end
      if (anima==15) graph=3;end
      if (anima==16) graph=3;end
      if (anima==17) graph=4;end
      if (anima==18) graph=4;disparo(x+12,y+5);end
      if (anima==19) graph=4;end
      if (anima==20) graph=3;end
      if (anima==21) graph=2;disparando=0;end
      if (anima==22) graph=1;end
      if (anima==23) anima=21;end

      if (collision(type enemigo01) or collision (type enemigo02))
        graph=15;energia=energia-1;
        signal(type alas,s_sleep);
        signal(id_disparo,s_kill);
        
        frame(500);
        graph=1;
        signal(type alas,s_wakeup);
      end

      if ((id_disparo=collision(type disparos_enemigos)))
        graph=15;energia=energia-2;
        signal(type alas,s_sleep);
        signal(id_disparo,s_kill);

        frame(500);
        graph=1;
        signal(type alas,s_wakeup);
      end
    
      if (collision(type enemigo03))
        graph=15;energia=energia-3;
        signal(type alas,s_sleep);
        signal(id_disparo,s_kill);

        frame(500);
        graph=1;
        signal(type alas,s_wakeup);
      end

      if (energia<1) muerte(x,y,z);
        signal(type alas,s_kill);
        break;
      end
    end

    if (fuera_de_pantalla==1)
      x=x+6;if (x>110) fuera_de_pantalla=0;end
    end

    if (destapado==1)
      z=-20;
    else
      z=20;
    end

    ux=x; uy=y;

  frame;
  end
end


process alas(x,y,size,z);
  private;
    al_access=0;

  begin
    graph=10;
    file=fichero1;
    priority=-1;
    region=1;

  loop
    if (al_access==0)
      graph=graph+1;if (graph>13) graph=13;al_access=1;end
    end

    if (al_access==1)
      graph=graph-1;if (graph<11) graph=10;al_access=0;end
    end

    if (destapado==1)
      z=-25;
    else
      z=15;
    end

    x=father.x-3; y=father.y+2;

  frame;
  end
end


process disparo(x,y);
  begin
    graph=14;
    size=100;
    z=30;
    file=fichero1;
    region=1;

    play_wav(sonido0,0);

  loop
    x=x+8;if (x>350) break;end

    if (destapado==1)
      z=-15;
    else
      z=30;
    end

  frame;
  end
end


process vidas(x,y,por_vidas);
  private;
    movi_vidas=0;
    ok_vidas=0;

  begin
    graph=36;
    size=100;
    z=0;
    file=fichero1;
    region=1;

  loop
    movi_vidas=rand(0,60);
    if (movi_vidas==0) ok_vidas=1;end

    if (ok_vidas==1)
      graph=graph+1;if (graph>43) graph=36;ok_vidas=0;end
    end

    if (por_vidas==1)
      if (life<1) graph=76;end
    end

    if (por_vidas==2)
      if (life<2) graph=76;end
    end

    if (por_vidas==3)
      if (life<3) graph=76;end
    end

  frame;
  end
end


process muerte(x,y,z);
  begin
    graph=16;
    size=100;
    file=fichero1;
    region=1;

    life=life-1;

  loop
    angle=angle-2000;
    size=size+1;
    y=y+4;
    if (y>230 and energia<1)
      if (life>0) play_wav(sonido1,0);energia=26;prota(-40,120,1);end
      if (life==0)
        play_wav(sonido1,0);
        game_over();
        if (puntos>hi_score) hi_score=puntos;end
        save("record.sav",hi_score);
        frame(10000);
        fade_off();
        frame(1000);
        
        stop_scroll(0);
        delete_text(all_text);

        inicio();
      end
    end
    if (y>260) break;end

  frame;
  end
end


process fondo();
  begin
    start_scroll(0,fichero2,4,5,1,5);
    scroll.camera=id;
    ctype=c_scroll;

  loop
    x=x+2;

  frame;
  end
end


process decorado(graph,x,y,size,z,velocidad_decorado,top,retorna);
  begin
    file=fichero2;
    region=1;

  loop
    x=x-velocidad_decorado;if (x<top) x=retorna;end
    if (x<-50000) break;end

  frame;
  end
end


process enemigo01(topx,y);
  private;
    anima=0;      //para la animacion del enemigo1...
    animation=0;
    tiempo_reaccion=0;      //duracion de un disparo a otro...
    id_disparo;        //para identificar el disparo del prota..
    ene_energi=3;     //energia del enemigo1...
    veces_muerto=0;    //para averiguar cuantos toques le das despues de haber muerto...

  begin
    graph=21;
    x=360;
    size=100;
    z=25;
    file=fichero1;
    region=1;

    y=y+20;

  loop
    if (ene_energi>0)
      if (ux>x) flags=1;end
      if (ux<x) flags=0;end

      if (animation==0)
        graph=graph+1;if (graph>24) graph=24;animation=1;end
      end
      if (animation==1)
        graph=graph-1;if (graph<21) graph=21;animation=0;end
      end

      if (anima==0)
        x=x-4;if (x<topx) x=topx;anima=1;tiempo_reaccion=0;end
      end
      if (anima==1)
        tiempo_reaccion=tiempo_reaccion+1;
        if (tiempo_reaccion>50)
          anima=rand(0,10);
          tiempo_reaccion=0;
        end
      end
      if (anima==2)
        x=x-5;if (x<-60) x=360;anima=0;animation=0;end
        tiempo_reaccion=tiempo_reaccion+1;
        if (tiempo_reaccion>9) graph=25;end
        if (tiempo_reaccion==11) disparos_enemigos(x,y-10,0,0);end
        if (tiempo_reaccion>12) tiempo_reaccion=0;end
      end
      if (anima==3)
        tiempo_reaccion=tiempo_reaccion+1;
        if (tiempo_reaccion>9) graph=25;end
        if (tiempo_reaccion==11) disparos_enemigos(x,y-10,0,0);end
        if (tiempo_reaccion>12) anima=0;animation=0;end
      end
      if (anima>3) anima=1;end
    end
    
    if ((id_disparo=collision(type disparo)))
      graph=26;ene_energi=ene_energi-1;
      animation=0;
      signal(id_disparo,s_kill);frame(500);
      if (ene_energi<1) veces_muerto+=1;multiplica(x,y-10,veces_muerto,25);end
    end

    if (ene_energi==0)
      enemigos=enemigos-1;
      ene_energi=ene_energi-1;
    end
    if (ene_energi<1)
      graph=27;angle=angle+2000;y=y+3;
      if (y>260) play_wav(sonido1,0);break;end
    end

  frame;
  end
end


process enemigo02(topx,y);
  private;
    anima=0;      //para la animacion del enemigo1...
    animation=0;
    tiempo_reaccion=0;      //duracion de un disparo a otro...
    id_disparo;        //para identificar el disparo del prota..
    ene_energi=4;     //energia del enemigo1...
    veces_muerto=0;    //para averiguar cuantos toques le das despues de haber muerto...

  begin
    graph=72;
    x=360;
    size=100;
    z=25;
    file=fichero1;
    region=1;

    y=y+20;

  loop
    if (ene_energi>0)
      if (animation==0)
        graph=graph+1;if (graph>75) graph=75;animation=1;end
      end
      if (animation==1)
        graph=graph-1;if (graph<72) graph=72;animation=0;end
      end
      
      if (anima==0)
        x=x-4;if (x<topx) x=topx;anima=1;tiempo_reaccion=0;end
      end
      if (anima==1)
        tiempo_reaccion=tiempo_reaccion+1;
        if (tiempo_reaccion>50)
          anima=rand(0,12);
          tiempo_reaccion=0;
        end
      end
      if (anima==2)
        x=x-5;if (x<-60) x=360;anima=0;animation=0;end
        tiempo_reaccion=tiempo_reaccion+1;
        if (tiempo_reaccion>9) graph=77;end
        if (tiempo_reaccion==11)
          disparos_enemigos(x+10,y-12,0,1);
          disparos_enemigos(x+10,y-12,45000,1);
          disparos_enemigos(x+10,y-12,90000,1);
          disparos_enemigos(x+10,y-12,135000,1);
          disparos_enemigos(x+10,y-12,180000,1);
          disparos_enemigos(x+10,y-12,225000,1);
          disparos_enemigos(x+10,y-12,270000,1);
          disparos_enemigos(x+10,y-12,315000,1);
        end
        if (tiempo_reaccion>20) tiempo_reaccion=0;end
      end
      if (anima==3)
        tiempo_reaccion=tiempo_reaccion+1;
        if (tiempo_reaccion>9) graph=77;end
        if (tiempo_reaccion==11)
          disparos_enemigos(x+10,y-12,0,1);
          disparos_enemigos(x+10,y-12,45000,1);
          disparos_enemigos(x+10,y-12,90000,1);
          disparos_enemigos(x+10,y-12,135000,1);
          disparos_enemigos(x+10,y-12,180000,1);
          disparos_enemigos(x+10,y-12,225000,1);
          disparos_enemigos(x+10,y-12,270000,1);
          disparos_enemigos(x+10,y-12,315000,1);
        end
        if (tiempo_reaccion>12) anima=0;animation=0;end
      end
      if (anima>3) anima=1;end
    end

    if ((id_disparo=collision(type disparo)))
      graph=79;ene_energi=ene_energi-1;
      signal(id_disparo,s_kill);frame(500);
      animation=0;
      if (ene_energi<1) veces_muerto+=1;multiplica(x,y-10,veces_muerto,50);end
    end

    if (ene_energi==0)
      enemigos=enemigos-1;
      ene_energi=ene_energi-1;
    end
    if (ene_energi<1)
      graph=80;angle=angle+2000;y=y+3;
      if (y>260) play_wav(sonido1,0);break;end
    end

  frame;
  end
end


process enemigo03(topx,topy);
  private;
    anima=0;      //para la animacion del enemigo1...
    animation=0;
    tiempo_reaccion=0;      //duracion de un disparo a otro...
    id_disparo;        //para identificar el disparo del prota..
    ene_energi=5;     //energia del enemigo1...
    veces_muerto=0;    //para averiguar cuantos toques le das despues de haber muerto...

  begin
    graph=85;
    x=360;
    y=topy;
    size=100;
    z=25;
    file=fichero1;
    region=1;

    y=y+20;

  loop
    if (ene_energi>0)
      if (animation==0)
        graph=graph+1;if (graph>88) graph=88;animation=1;end
      end
      if (animation==1)
        graph=graph-1;if (graph<85) graph=85;animation=0;end
      end

      if (anima==0)
        x=x-4;if (x<topx) x=topx;anima=1;tiempo_reaccion=0;end
        y=topy;
      end
      if (anima==1)
        tiempo_reaccion=tiempo_reaccion+1;
        if (tiempo_reaccion>50)
          anima=rand(0,12);
          tiempo_reaccion=0;
        end
      end
      if (anima==2)
        x=x-6;if (x<-60) x=360;anima=0;end
        if (uy>y) y=y+3;end
        if (uy<y) y=y-3;end
      end
      if (anima>2) anima=1;end
    end

    if ((id_disparo=collision(type disparo)))
      graph=89;ene_energi=ene_energi-1;
      signal(id_disparo,s_kill);frame(500);
      animation=0;
      if (ene_energi<1) veces_muerto+=1;multiplica(x,y-10,veces_muerto,75);end
    end

    if (ene_energi==0)
      enemigos=enemigos-1;
      ene_energi=ene_energi-1;
    end
    if (ene_energi<1)
      graph=90;angle=angle+2000;y=y+3;
      if (y>260) play_wav(sonido1,0);break;end
    end

  frame;
  end
end


process disparos_enemigos(x,y,angulo_disparo,tipo);
  private;
    direccion_prota;

  begin
    if (tipo==0)
      graph=28;
      size=100;
      z=30;
      file=fichero1;
      direccion_prota=fget_angle(x,y,ux,uy);
    end
    if (tipo==1)
      graph=78;
      size=100;
      z=30;
      file=fichero1;
    end
    region=1;
    
  loop
    if (tipo==0)
      xadvance(direccion_prota,8);if (x<-10 or x>330 or y<-10 or y>250) break;end
    end
    if (tipo==1)
      xadvance(angulo_disparo,8);if (x<-10 or x>330 or y<-10 or y>250) break;end
    end

  frame;
  end
end


process multiplica(x,y,x_cent,valor_enemigo);
  private;
    sube=42;

  begin
    z=30;
    size=100;
    file=fichero1;
    region=1;
    if (x_cent==1) graph=29;puntos=puntos+valor_enemigo*2;end
    if (x_cent==2) graph=30;puntos=puntos+valor_enemigo*4;end
    if (x_cent==3) graph=31;puntos=puntos+valor_enemigo*6;end
    if (x_cent==4) graph=32;puntos=puntos+valor_enemigo*8;end
    if (x_cent>4) graph=33;puntos=puntos+valor_enemigo*10;end
    if (x_cent>11) graph=19;puntos=puntos+valor_enemigo*100;end
    if (x_cent>14) graph=83;puntos=puntos+valor_enemigo*250;end

  loop
    y=y-2;sube=sube-1;size=size+5;
    if (sube<5) flags=4;size=size+5;end
    if (sube<12) angle=angle+15000;size=size+5;end
    if (sube==0) break;end

  frame;
  end
end


process energy();
  begin
    x=155;
    y=31;
    size=100;
    z=-5;
    file=fichero1;
    region=1;

  loop
    if (energia==26) graph=45;end
    if (energia==25) graph=46;end
    if (energia==24) graph=47;end
    if (energia==23) graph=48;end
    if (energia==22) graph=49;end
    if (energia==21) graph=50;end
    if (energia==20) graph=51;end
    if (energia==19) graph=52;end
    if (energia==18) graph=53;end
    if (energia==17) graph=54;end
    if (energia==16) graph=55;end
    if (energia==15) graph=56;end
    if (energia==14) graph=57;end
    if (energia==13) graph=58;end
    if (energia==12) graph=59;end
    if (energia==11) graph=60;end
    if (energia==10) graph=61;end
    if (energia==9) graph=62;end
    if (energia==8) graph=63;end
    if (energia==7) graph=64;end
    if (energia==6) graph=65;end
    if (energia==5) graph=66;end
    if (energia==4) graph=67;end
    if (energia==3) graph=68;end
    if (energia==2) graph=69;end
    if (energia<=1) graph=70;end

  frame;
  end
end


process titulo_escenario();
  private;
    fuera_escena=0;

  begin
    graph=8;
    x=-200;
    y=100;
    size=100;
    z=-30;
    file=fichero2;
    region=1;

  loop
    fuera_escena=fuera_escena+1;

    if (fuera_escena<100)
      x=x+10;if (x>160) x=160;end
    end

    if (fuera_escena>100)
      x=x+10;if (x>500) break;end
    end

  frame;
  end
end


process game_over();
  begin
    graph=200;
    x=160;
    y=120;
    size=100;
    z=-30;
    file=fichero1;
    region=1;
    
  loop
    graph=graph+1;if (graph>216) graph=200;end

  frame;
  end
end


process final();
  private;
    id_mov1;
    id_mov2;
    tiempo=0;
  
  begin
    fade_off();
    let_me_alone();

    stop_scroll(0);
    delete_text(all_text);

    fade_on();

    stop_song();
    unload_song(musica);

    musica=load_song("music_sound/joc-dgm.xm");
    play_song(musica,-1);

    id_mov1=foto(21,160,100,100,10,0,fichero2);
    id_mov2=foto(22,160,300,100,10,0,fichero2);

  loop
    tiempo=tiempo+1;
    if (tiempo>300)
      id_mov1.y-=1;id_mov2.y-=1;
      if (id_mov2.y<-160) amakasoft();end
      tiempo=300;
    end

  frame;
  end
end
  

